(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["restricted-number"] = factory();
	else
		root["restricted-number"] = factory();
})(typeof self !== 'undefined' ? self : this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(1));


/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
class RestrictedNumber {
    get total() {
        return this.__current;
    }
    set total(num) {
        this.__current = num;
    }
    constructor(minimum, maximum, current = maximum) {
        this.minimum = minimum;
        this.maximum = maximum;
        this.set(current);
        if (this.maximum < this.minimum)
            throw new Error('RestrictedNumber: Max should be above min');
    }
    // chainable operators
    set(num) {
        num = Math.min(num, this.maximum);
        num = Math.max(num, this.minimum);
        this.__current = num;
        return this;
    }
    add(num) {
        return this.set(this.__current + num);
    }
    sub(num) {
        return this.add(-num);
    }
    addOverMaximum(num) {
        this.maximum += num;
        return this.add(num);
    }
    subUnderMinimum(num) {
        this.minimum -= num;
        return this.sub(num);
    }
    // max/min set functions
    toMaximum() {
        return this.set(this.maximum);
    }
    toMinimum() {
        return this.set(this.minimum);
    }
    atMaximum() {
        return this.maximum <= this.total;
    }
    atMinimum() {
        return this.minimum >= this.total;
    }
    // value checking functions
    gt(num) {
        return this.total > num;
    }
    gte(num) {
        return this.total >= num;
    }
    lt(num) {
        return this.total < num;
    }
    lte(num) {
        return this.total <= num;
    }
    // percentage functions
    setToPercent(perc) {
        return this.set(perc * ((this.maximum - this.minimum) / 100));
    }
    addPercent(perc) {
        return this.add(perc * ((this.maximum - this.minimum) / 100));
    }
    subPercent(perc) {
        return this.addPercent(-perc);
    }
    asPercent() {
        return Math.floor((this.total / this.maximum) * 100);
    }
    // percentage checking functions
    gtPercent(perc) {
        return this.asPercent() > perc;
    }
    gtePercent(perc) {
        return this.asPercent() >= perc;
    }
    ltPercent(perc) {
        return this.asPercent() < perc;
    }
    ltePercent(perc) {
        return this.asPercent() <= perc;
    }
}
exports.RestrictedNumber = RestrictedNumber;


/***/ })
/******/ ]);
});
//# sourceMappingURL=index.js.map